"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.evaluate = evaluate;

var _require = require("./kernel/exec"),
    executeStackFrame = _require.executeStackFrame;

var _require2 = require("./kernel/stackframe"),
    createStackFrame = _require2.createStackFrame;

var _module = require("./runtime/values/module");

var t = require("../compiler/AST");

function evaluate(allocator, code) {
  // Create an empty module instance for the context
  var moduleInstance = _module.createInstance(allocator, t.module(undefined, []));

  var stackFrame = createStackFrame(code, [], moduleInstance, allocator);
  var res = executeStackFrame(stackFrame);
  return res;
}