"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.t = exports.traverse = exports.parsers = exports.printers = void 0;

var _require = require("./compiler/parsing/watf"),
    parseSource = _require.parseSource;

var _require2 = require("./compiler/parsing/wasm"),
    parseBinary = _require2.parseBinary;

var _require3 = require("./compiler/AST/traverse"),
    traverse = _require3.traverse;

exports.traverse = traverse;

var t = require("./compiler/AST/index");

exports.t = t;

var _require4 = require("./compiler/printer/wast"),
    printWAST = _require4.printWAST;

var printers = {
  printWAST: printWAST
};
exports.printers = printers;
var parsers = {
  parseWATF: function parseWATF(content) {
    return parseSource(content);
  },
  parseWATFSpecTest: function parseWATFSpecTest(content) {
    return parseSource(content);
  },
  parseWASM: function parseWASM(content) {
    return parseBinary(content);
  }
};
exports.parsers = parsers;